%Discretizzazione del Sistema (by Andrea Pratic 2003)

%Sistema a Tempo Continuo

%Sistema G2(s)
numG2=[1208];
denG2=[1 15 50];

%Controllore Gc(s)
Kc=9.1;
numGc=Kc*[1 11.68 112.03];
denGc=[1 235.3 0];

%f.d.t. in catena diretta
numGd=conv(numG2,numGc);
denGd=conv(denG2,denGc);


%f.d.t. in reazione unitaria
[numW,denW]=feedback(numGd,denGd,1,1);

%Risposta al Gradino del Sistema Tempo Continuo chiuso in reazione

t=0:0.001:0.5;	%Intervallo di Visualizzazione
hc=step(numW,denW,t);
figure;
plot(t,hc,'b');
axis([0 0.5 0.0 1.25]);
hold on;



%Sistema a Tempo Discreto.

%Banda Passante del Sistema Chiuso in reazione
B3=51.37;		%Banda Passante in rad/s
f3=B3/(2*pi);	%Banda Passante in Hz

fc=30*f3;	%Frequenza di Campionamento (Metodo di Franklin)
T=1/fc;		%Tempo di Campionamento calcolato
T=0.004;		%Tempo di Campionamento imposto

%DISCRETIZZAZIONE CON TUSTIN

[numD2,denD2]=c2dm(numG2,denG2,T,'tustin'); 	%Discretizz. del Sistema con Tustin
[numDc,denDc]=c2dm(numGc,denGc,T,'tustin');	%Discretizz. del Controllore con Tustin
[numDd,denDd]=c2dm(numGd,denGd,T,'tustin');	%Discretizz. del S.in catena dir (Tustin)

'Sistema da Controllare Discretizzato'
G2z=tf(numD2,denD2,T)

'Controllore Discretizzato (Tustin)'
T
Gcz=tf(numDc,denDc,T)		%Controllore Discretizzato con Tustin

Gdz=tf(numDd,denDd,T);			%Gd=G2z*Gcz sistema discretizz.in catena diretta

[numWd,denWd]=feedback(numDd,denDd,1,1);	%Sistema discretiz.in catena chiusa
%N=fix(max(t)/T);	%Numero di campioni da visualizzare
%hd=dstep(numWd,denWd,N);	%Risposta al gradino
%td=0:T:(N-1)*T;
%plot(td,hd,'.g');
title('Risposta al Gradino. T=0.004 (Tustin)');
xlabel('Tempo [sec]');
ylabel('Ampiezza');
load Gradino
plot(Gra(1,:),Gra(2,:),'.r')
legend('Continuo','Discretizzato');
hold off;
figure;
hold on;
axis equal;
axis([-1.5 1.5 -1.5 1.5]);
rlocus(numDd,denDd);
teta=0:0.001:2*pi;
plot(cos(teta),sin(teta),'b:');



